#! /usr/bin/env python
# -*- Mode: Python -*-
# -*- coding: ascii -*-

__author__     = "Me"
__date__       = "Today"
__copyright__  = "Me"
__version__    = "1.0"
__maintainer__ = "Me"
__email__      = "me@localhost"
__status__     = ""
__lwver__      = "11"

import os, sys, math, traceback
import lwsdk
from lwsdk import OPSEL_USER as USER_SEL
from lwsdk import OPSEL_GLOBAL as GLOBAL_SEL
from lwsdk import OPSEL_DIRECT as DIRECT_SEL
from lwsdk import EDERR_USERABORT as CANCEL_MEO
from lwsdk import EDERR_NONE 
import lwsdk.pris.modeler

lwpm = lwsdk.pris.modeler

class pts2crv(lwsdk.ICommandSequence):
	def __init__(self, context):
		super(pts2crv, self).__init__()
		self.mo = None

	def process(self, mod_command):
		pts = []
		c = []
		mc = mod_command
		vme = False
		use_parts = 0
		t = []
		
		#Main Code Starts Here
		#region
		#We'll need a simple UI
		#Not worrying about existing parts and surfaces
		self.ui    = lwsdk.LWPanels()
		self.panel = self.ui.create("Points to Curves")
		
		self.c1 = self.panel.boolbutton_ctl("Use Parts")
		self.c1.set_int(0)
				
		self.c2 = self.panel.str_ctl("Part or Surface Name",40)
		self.c2.set_str("Default")
		
		self.panel.align_controls_vertical([self.c2,self.c1])
		self.panel.size_to_layout(5, 5)
		
		if self.panel.open(lwsdk.PANF_BLOCKING | lwsdk.PANF_CANCEL) == 0:
			self.ui.destroy(self.panel)
			return lwsdk.AFUNC_OK

		use_parts = self. c1.get_int()
		nm = self.c2.get_str()
		#endregion
		surfname = 'Default'
		partname = ''

		if use_parts: 
			partname = nm
		else:
			surfname = nm

		try:
			#meo = mc.editBegin(0,0,lwsdk.OPSEL_MODIFY | lwsdk.OPSEL_DIRECT)
			lwpm.init(mc)
			lwpm.selmode(DIRECT_SEL)
			lwpm.undogroupbegin()
			lwpm.editbegin()
			meo = lwpm._local_me

			if not meo:
				lwsdk.LWMessageFuncs().error("Mesh Edit Failed.","")
				return lwsdk.AFUNC_OK
			
			vme = True
			pts = lwpm.getpoints()
			#eor = meo.fastPointScan(meo.state, self.fast_point_scan,(pts,),lwsdk.OPLYR_FG, 1)
			
			'''if eor != lwsdk.EDERR_NONE:
				lwsdk.LWMessageFuncs().error("Point Scan Failed.","")
				return lwsdk.AFUNC_OK'''
			
			if not len(pts):
				lwsdk.LWMessageFuncs().error("No Points Selected.","")
				return lwsdk.AFUNC_OK
			
			#Now, to make 1pt curves...
			#res = mc.evaluate(mc.data,"SEL_POLYGON \"CLEAR\"")
			lwpm.selpoint('CLEAR','NPEQ', 0)
			lwpm.selpolygon('CLEAR','NVGT',0)
			for v in pts:
				l = [v]
				t.append(lwpm.addcurve(l,surfname))

		except:
			print "We've had an error, closing down gracefully..."
			err = traceback.format_exc()
			print "Error : ", err 
		finally:
			if vme: 
				lwpm.editend()
				if t: 
					lwpm.selpolygon('SET',"POLYID",t)
					if use_parts: lwpm.changepart(partname)
			lwpm.undogroupend()

		return lwsdk.AFUNC_OK
			
ServerTagInfo = [( "pts2crv", lwsdk.SRVTAG_USERNAME | lwsdk.LANGID_USENGLISH ),
                 ( "Points to Curves", lwsdk.SRVTAG_BUTTONNAME | lwsdk.LANGID_USENGLISH )]
ServerRecord = { lwsdk.CommandSequenceFactory("Points to Curves", pts2crv) : ServerTagInfo }

