#! /usr/bin/env python
# -*- Mode: Python -*-
# -*- coding: ascii -*-

__author__     = "Kryslin"
__date__       = "03 Sept 2018"
__copyright__  = "Kryslin"
__version__    = "1.0"
__maintainer__ = "Kryslin"
__email__      = "Kryslin"
__status__     = ""
__lwver__      = "11"

import os, sys, math, traceback
import lwsdk

class crv_endpt_sel(lwsdk.ICommandSequence):
	def __init__(self, context):
		super(crv_endpt_sel, self).__init__()
		
		self.meop = None
		
	def fast_poly_scan(self, crv_list, poly_id):
		smeo = self.meop
		q = smeo.polyType(smeo.state, poly_id)
		if q == lwsdk.LWPOLTYPE_CURV:
			crv_list.append(poly_id)
	
	def process(self, mod_command):
		tmp = []
		polycnt = 0
		res = 0
		lmeo = None
		t2 = []
		try:
			mc = mod_command
			self.meop = mc.editBegin(0,0,lwsdk.OPSEL_MODIFY | lwsdk.OPSEL_DIRECT)
			if not self.meop:
				lwsdk.LWMessageFuncs().error("Mesh Edit Failed.","")
				return lwsdk.AFUNC_OK
			lmeo = self.meop
			polycnt = lmeo.polyCount(lmeo.state, lwsdk.OPLYR_FG, lwsdk.EDCOUNT_SELECT)
			if not polycnt:
				lwsdk.LWMessageFuncs().error("Nothing Selected.","")
				return lwsdk.AFUNC_OK
			eo_r = lmeo.fastPolyScan(lmeo.state, self.fast_poly_scan, (tmp,), lwsdk.OPLYR_FG, 1)
			if eo_r != lwsdk.EDERR_NONE:
				lmeo.done(meo.state, eo_r,0)
				return lwsdk.AFUNC_OK
			if not len(tmp):
				lmeo.done(meo.state, eo_r,0)
				lwsdk.LWMessageFuncs().error("No Curves Selected.","")
				return lwsdk.AFUNC_OK
			
			res = mc.evaluate(mc.data, "SEL_POINT \"CLEAR\"")
			
			for crv in tmp:
				t2 = lmeo.polyPoints(lmeo.state, crv)
				res = lmeo.polSelect(lmeo.state, crv, 0)
				res = lmeo.pntSelect(lmeo.state, t2[len(t2)-1], 1)
		except:
			print("We've had an error, closing down mesheditop gracefully...")
			err = traceback.format_exc()
			print("Error : ", err)	
		finally:
			res = lmeo.done(lmeo.state, lwsdk.EDERR_NONE, 0)
			
		return lwsdk.AFUNC_OK

ServerTagInfo = [( "Sel Curve End", lwsdk.SRVTAG_USERNAME | lwsdk.LANGID_USENGLISH ),
                 ( "Sel Curve End", lwsdk.SRVTAG_BUTTONNAME | lwsdk.LANGID_USENGLISH )]
ServerRecord = { lwsdk.CommandSequenceFactory("Select Curve End", crv_endpt_sel) : ServerTagInfo }

