#! /usr/bin/env python
# -*- Mode: Python -*-
# -*- coding: ascii -*-

__author__     = "Steven Pettit"
__date__       = "05 Aug 2020"
__copyright__  = "Steven Pettit"
__version__    = "1.0"
__maintainer__ = "Steven Pettit"
__email__      = "kryslin@tlhea.org"
__status__     = ""
__lwver__      = "11"

import os, sys, math, traceback
import lwsdk
import lwsdk.pris.modeler

lwpm = lwsdk.pris.modeler

class selNextCP(lwsdk.ICommandSequence):
	def __init__(self, context):
		super(selNextCP, self).__init__()
				
	def process(self, mod_command):
		selv = []
		selp = []
		pinf = []
		pcnt = 0
		newv = 0
		oldv = 0

		lwpm.init(mod_command)
		lwpm.selmode(lwsdk.OPSEL_DIRECT | lwsdk.OPSEL_MODIFY)
		lwpm.editbegin()
		meo = lwpm._local_me
		try:
			v = lwpm.pointcount()
			if not v:
				lwsdk.LWMessageFuncs().error("Nothing Selected.","")
				return lwsdk.AFUNC_OK

			#I need these as lists, not tuples.
			selv = list(lwpm.getpoints())
			selp = list(lwpm.getpolygons())
			for v in selv:
			#Since pris has no equivalent to the polygon/.polygon() of the lscript polygon object agent...
			#How do I work around this... polypoint and polypointinfo?
				for p in selp:
					pinf = lwpm.polyinfo(p)
					pcnt = lwpm.polypointinfo(p)
					if v in pinf:
						vlist = pinf[1:]
						oldv = vlist.index(v)
						newv = min(pcnt -1, oldv + 1)
						w = vlist[newv]
						meo.pntSelect(meo.state, v, 0)
						meo.pntSelect(meo.state, w, 1)
						selp.pop(selp.index(p))
						break
		except:
			print "We've had an error, closing down gracefully..."
			err = traceback.format_exc()
			print "Error : ", err 
		finally:
			lwpm.editend()

		return lwsdk.AFUNC_OK
			
ServerTagInfo = [( "selNextCP", lwsdk.SRVTAG_USERNAME | lwsdk.LANGID_USENGLISH ),
                 ( "Next CP", lwsdk.SRVTAG_BUTTONNAME | lwsdk.LANGID_USENGLISH )]
ServerRecord = { lwsdk.CommandSequenceFactory("Next CP", selNextCP) : ServerTagInfo }

